//+------------------------------------------------------------------+
//|                                                       Tester.mq5 |
//|                                Copyright 2010, PB-X Investments. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, PB-X Investments."
#property link      "http://www.mql5.com"
#property version   "1.00"
#include <PrintComment.mqh>
#include <SendOrder.mqh>
#include <ModifyPosition.mqh>
#include <ModifyOrder.mqh>
#include <CloseOrder.mqh>
#include <DeleteOrder.mqh>

input      int   Delta=10;    //Pips to pass resitance or support to enter trade

int ZigZaghandle;
double ZizZagbuffer[],ZizZagbufferhighs[],ZizZagbufferlows[];
double lows[5][2];
double highs[5][2];
double Current_res, Current_sup, stp, tgt;
int    Pos_res, Pos_sup, delta;
bool              newbar;
datetime          time0[1];
static datetime   oldtime;
string            text;
MqlTick           CurrentPrice;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   ZigZaghandle=iCustom(_Symbol,0,"Examples\\ZigZag",12,5,3);
   if(ZigZaghandle==INVALID_HANDLE) Alert("Cannot call indicator");
   ArraySetAsSeries(ZizZagbuffer,true);ArraySetAsSeries(ZizZagbufferhighs,true);ArraySetAsSeries(ZizZagbufferlows,true);
   
//---
   delta=Delta;
   if(_Digits==3 || _Digits==5)  {delta=Delta*10;}
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   IndicatorRelease(ZigZaghandle);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- detect new bar  
   newbar=false;
   int copied=CopyTime(_Symbol,PERIOD_H1,0,1,time0);
   if(copied<0){StringConcatenate(text,"Error copying time0, #",GetLastError());PrintComment(text);ResetLastError();}
   if(oldtime!=time0[0])
   {
      oldtime=time0[0];
      newbar=true;   
   }
   if(newbar==true)
   {
      Filter_swings();
      //Alert(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE));
      if(PositionSelect(_Symbol)==0)
      {
         SymbolInfoTick(_Symbol,CurrentPrice);
         if(CurrentPrice.ask > Current_res+delta*_Point && CurrentPrice.ask < Current_res+500*_Point)
         {
            stp=Current_sup;
            tgt=Current_res+(Current_res-Current_sup);
            SEND(_Symbol,"BUY",11111,0.2,CurrentPrice.ask,stp,tgt,"");
         }
         if(CurrentPrice.bid < Current_sup-delta*_Point && CurrentPrice.bid > Current_sup-500*_Point)
         {
            stp=Current_res;
            tgt=Current_sup-(Current_res-Current_sup);
            SEND(_Symbol,"SELL",22222,0.2,CurrentPrice.bid,stp,tgt,"");
         }
      }
   }  
  }
//+------------------------------------------------------------------+
bool Filter_swings()
{
   if(CopyBuffer(ZigZaghandle,0,0,Bars(_Symbol,0)-2,ZizZagbuffer)<0)       {Alert("Error");ResetLastError();return(0);}
   if(CopyBuffer(ZigZaghandle,1,0,Bars(_Symbol,0)-2,ZizZagbufferhighs)<0)  {Alert("Error");ResetLastError();return(0);}
   if(CopyBuffer(ZigZaghandle,2,0,Bars(_Symbol,0)-2,ZizZagbufferlows)<0)   {Alert("Error");ResetLastError();return(0);}
   int x; int l=0; int h=0;
   for(x=0 ; x<100 ; x++)
   {
      if(ZizZagbufferhighs[x]!=0 && ZizZagbuffer[x]!=0)  {if(h<5){highs[h][0]=x;highs[h][1]=ZizZagbufferhighs[x];h++;}}  
      if(ZizZagbufferlows[x]!=0 && ZizZagbuffer[x]!=0)   {if(l<5){lows[l][0]=x;lows[l][1]=ZizZagbufferlows[x];l++;}}
      if(h>=5 && l>=5)break;  
   }
   //Searching for last resistance
   for(x=0;x<5;x++)  
   {
      if(highs[x][0]>4)
      {
         Current_res=highs[x][1];
         Pos_res=highs[x][0];
         break;
      }
   }   
   //Searching for last support
   for(x=0;x<5;x++)  
   {
      if(lows[x][0]>4)
      {
         Current_sup=lows[x][1];
         Pos_sup=lows[x][0];
         break;
      }
   }
   //Alert("Res: ",Pos_res," ",Current_res," Sup: ",Pos_sup," ",Current_sup);
   return(1);
}
